#!/bin/sh

set -eu

ROOT=`pwd`

OUT="${ROOT}/$1"
shift
INPUT="${ROOT}/$1"
shift

TMP_DIR=${TMPDIR:-/tmp}
WRKDIR="$(mktemp -d ${TMP_DIR%%/}/bazel.XXXXXXXX)"
trap "rm -fr \"${WRKDIR}\"" EXIT

LOGFILE="${WRKDIR}/log"
touch ${LOGFILE}

cp "${INPUT}" "${WRKDIR}/file.eps"

cd ${WRKDIR}

if grep -q '/stage.*bind def' "${WRKDIR}/file.eps"
then
	echo '=== setting stage ===' >> "${LOGFILE}"
	cat > "${WRKDIR}/stage.ed" <<EOF
1
/\\/stage.*bind def
d
a
/stage { $STAGE } bind def
.
w
q
EOF
	echo '= ed script is =' >> "${LOGFILE}"
	cat "${WRKDIR}/stage.ed" >> "${LOGFILE}"
	echo '= ed output is =' >> "${LOGFILE}"
	ed "${WRKDIR}/file.eps" < "${WRKDIR}/stage.ed" >> "${LOGFILE}" 2>&1 \
		|| { cat "${LOGFILE}"; exit 1; }
fi

if grep -q '/drawbb.*bind def' "${WRKDIR}/file.eps"
then
	echo '=== setting drawbb ===' >> "${LOGFILE}"
	cat > "${WRKDIR}/stage.ed" <<EOF
1
/\\/drawbb.*bind def
d
a
/drawbb { $DRAWBB } bind def
.
w
q
EOF
	echo '= ed script is =' >> "${LOGFILE}"
	cat "${WRKDIR}/stage.ed" >> "${LOGFILE}"
	echo '= ed output is =' >> "${LOGFILE}"
	ed "${WRKDIR}/file.eps" < "${WRKDIR}/stage.ed" >> "${LOGFILE}" 2>&1 \
		|| { cat "${LOGFILE}"; exit 1; }
fi

cp "${WRKDIR}/file.eps" "${OUT}"
